"use strict";

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createFormContext = void 0;

var React = _interopRequireWildcard(require("react"));

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { default: obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj.default = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

// Note: need to use a generic function in order to use a generic React context
// https://stackoverflow.com/a/52648865/233884
var createFormContext = function createFormContext() {
  // Note: don't have an initial value, because we don't yet know the instance
  var FormContext = /*#__PURE__*/React.createContext(null);

  var FormProvider = function FormProvider(_ref) {
    var buffer = _ref.buffer,
        updateBuffer = _ref.updateBuffer,
        children = _ref.children;
    var formContext = {
      buffer: buffer,
      methods: {
        updateBuffer: updateBuffer
      }
    };
    return /*#__PURE__*/React.createElement(FormContext.Provider, {
      value: formContext
    }, children);
  };

  var useForm = function useForm() {
    return React.useContext(FormContext);
  };

  return {
    FormContext: FormContext,
    FormProvider: FormProvider,
    FormConsumer: FormContext.Consumer,
    useForm: useForm
  };
};

exports.createFormContext = createFormContext;
//# sourceMappingURL=FormContext.js.map