import * as React from 'react';
// Note: need to use a generic function in order to use a generic React context
// https://stackoverflow.com/a/52648865/233884
export var createFormContext = function createFormContext() {
  // Note: don't have an initial value, because we don't yet know the instance
  var FormContext = /*#__PURE__*/React.createContext(null);

  var FormProvider = function FormProvider(_ref) {
    var buffer = _ref.buffer,
        updateBuffer = _ref.updateBuffer,
        children = _ref.children;
    var formContext = {
      buffer: buffer,
      methods: {
        updateBuffer: updateBuffer
      }
    };
    return /*#__PURE__*/React.createElement(FormContext.Provider, {
      value: formContext
    }, children);
  };

  var useForm = function useForm() {
    return React.useContext(FormContext);
  };

  return {
    FormContext: FormContext,
    FormProvider: FormProvider,
    FormConsumer: FormContext.Consumer,
    useForm: useForm
  };
};
//# sourceMappingURL=FormContext.js.map