function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _iterableToArrayLimit(arr, i) { if (typeof Symbol === "undefined" || !(Symbol.iterator in Object(arr))) return; var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _unsupportedIterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _iterableToArray(iter) { if (typeof Symbol !== "undefined" && Symbol.iterator in Object(iter)) return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) return _arrayLikeToArray(arr); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

import * as O from 'optics-ts';
import { classNames as cx } from './util/components.js';
import * as React from 'react';
import { createFormContext } from './FormContext.js'; //import type {} from './FormContext.js';

// Accessor, or a path (string)
var isPath = function isPath(path) {
  return typeof path === 'string';
};

export var makeForm = function makeForm() {
  var _createFormContext = createFormContext(),
      FormProvider = _createFormContext.FormProvider,
      useForm = _createFormContext.useForm;

  var useAccessor = function useAccessor(accessor) {
    var _O$optic;

    var context = useForm();
    var accessorParsed = typeof accessor === 'string' || typeof accessor === 'number' || _typeof(accessor) === 'symbol' ? O.optic().path(accessor) : Array.isArray(accessor) ? (_O$optic = O.optic()).path.apply(_O$optic, _toConsumableArray(accessor)) : // FIXME
    accessor;
    var buffer = React.useMemo(function () {
      return O.get(accessorParsed)(context.buffer);
    }, [context.buffer, accessorParsed]);
    var updateBuffer = React.useCallback(function (fieldBufferUpdated) {
      return context.methods.updateBuffer(function (buffer) {
        return O.set(accessorParsed)(fieldBufferUpdated)(context.buffer);
      });
    }, [context.buffer, accessorParsed]);
    return {
      buffer: buffer,
      updateBuffer: updateBuffer
    };
  };
  /*
  type FieldProps<F> = {
      accessor: AccessorProp<A, F>,
      children?: RenderProp<{ buffer: F, updateBuffer: (bufferUpdated: F) => void }>,
  };
  const Field = <F,>({ accessor, children }: FieldProps<F>) => {
      const { fieldBuffer, updateFieldBuffer } = useAccessor(accessor);
      
      return typeof children === 'function'
          ? children({ buffer: fieldBuffer, updateBuffer: updateFieldBuffer })
          : children;
      
      /*
      // Ref: https://github.com/facebook/react/issues/15156#issuecomment-474590693
      const element = React.useMemo(() => {
          return typeof children === 'function'
              ? children({ buffer: fieldBuffer, updateBuffer: updateFieldBuffer })
              : children;
      }, [context.buffer, fieldBuffer]);
      
      return element;
      * /
  };
  */


  var InputText = function InputText(_ref) {
    var buffer = _ref.buffer,
        updateBuffer = _ref.updateBuffer,
        props = _objectWithoutProperties(_ref, ["buffer", "updateBuffer"]);

    return /*#__PURE__*/React.createElement("input", _extends({
      type: "text",
      value: buffer
    }, props, {
      className: cx(props.className),
      onChange: function onChange(evt) {
        updateBuffer(evt.target.value);

        if (typeof props.onChange === 'function') {
          props.onChange(evt);
        }
      }
    }));
  };

  var InputTextField = function InputTextField(_ref2) {
    var accessor = _ref2.accessor,
        props = _objectWithoutProperties(_ref2, ["accessor"]);

    var _useAccessor = useAccessor(accessor),
        inputBuffer = _useAccessor.buffer,
        updateInputBuffer = _useAccessor.updateBuffer;

    return /*#__PURE__*/React.createElement(InputText, _extends({}, props, {
      buffer: inputBuffer,
      updateBuffer: updateInputBuffer
    }));
  };

  return {
    FormProvider: FormProvider,
    useForm: useForm,
    useAccessor: useAccessor,
    accessor: O.optic(),
    path: function path(_path) {
      return O.optic().path(_path);
    },
    //Field,
    InputText: InputText,
    InputTextField: InputTextField
  };
}; // Default form context using a generic (`unknown`) type. Useful for untyped environments.

var FormContextGeneric = createFormContext();
export var FormContext = FormContextGeneric.FormContext;
export var FormProvider = FormContextGeneric.FormProvider;
export var FormConsumer = FormContextGeneric.FormConsumer;
export var useForm = FormContextGeneric.useForm;
var FormGeneric = makeForm();
export var InputText = FormGeneric.InputText; // Test

var Form = makeForm();
export var TestApp = function TestApp() {
  var _React$useState = React.useState({
    name: '',
    contact: {
      address: '',
      postalCode: '',
      phoneNumber: ''
    }
  }),
      _React$useState2 = _slicedToArray(_React$useState, 2),
      buffer = _React$useState2[0],
      setBuffer = _React$useState2[1];

  return /*#__PURE__*/React.createElement(Form.FormProvider, {
    buffer: buffer,
    updateBuffer: setBuffer
  }, /*#__PURE__*/React.createElement("form", null, /*#__PURE__*/React.createElement(Form.InputTextField, {
    accessor: O.optic().prop('name'),
    className: "name",
    placeholder: "Name"
  }), /*#__PURE__*/React.createElement(Form.InputTextField, {
    accessor: Form.path('contact.address'),
    className: {
      address: true
    },
    placeholder: "Address"
  }), /*#__PURE__*/React.createElement(Form.InputTextField, {
    accessor: ['contact', 'postalCode'],
    placeholder: "Postal code"
  }), /*#__PURE__*/React.createElement(Form.InputTextField, {
    accessor: "contact.phoneNumber",
    placeholder: "Phone number"
  })), /*#__PURE__*/React.createElement("pre", null, JSON.stringify(buffer, null, 2)));
};
//# sourceMappingURL=form.js.map